Imports Microsoft.VisualBasic
Imports System
Imports System.Linq
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports System.Runtime.InteropServices
Imports System.IO

Namespace GSensor
	Partial Public Class GSenor
		Inherits Form

		Private myGSensor1 As New myGSensor()
		Private mySensorData As New myGSensor.SensorData()
		Private mySensorDataOld As New myGSensor.SensorDataOld()

		'This value can be used to adjust how sensitive a scale you want to use
		'max is this value times the slider bars max (10)
		Private scalevalue As Integer = 150

		Public Sub New()
			InitializeComponent()

		End Sub

		Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load



		End Sub


		Private Sub timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles timer1.Tick
			'Reset background color
			shaketxt.BackColor = Color.White

			'Number of shake detections needed to trigger command
			Dim shakecounter As Integer = 3

			'Number of consecutive no shakes between shake detections needed to reset shakecounter
			Dim noshakecounter As Integer = 2

			'Get Sensor Date
			myGSensor1.GetSensorData(mySensorData)

			'Update screen with latest Sensor Data
			TiltX_txt.Text = mySensorData.TiltX.ToString()
			TiltY_txt.Text = mySensorData.TiltY.ToString()
			TiltZ_txt.Text = mySensorData.TiltZ.ToString()
			thetaX_txt.Text = mySensorData.AngleX.ToString()
			thetaY_txt.Text = mySensorData.AngleY.ToString()

			'Detect if the phone is being shook
			If myGSensor1.DetectShake(mySensorDataOld, mySensorData, threshold_trackBar.Value * scalevalue, shakecounter, noshakecounter) Then
				shaketxt.BackColor = Color.Red
				Dim VK_RIGHT As Byte = &H27
				If LaunchBox.Checked Then
				  myGSensor1.KeyCommandForApplication("wmplayer.exe", VK_RIGHT)
				End If
			End If

			'Update screen with additional information
			Counttxt.Text = myGSensor1.DetectWindowCount.ToString()
			NonCounttxt.Text = myGSensor1.ResetWindowCount.ToString()

			'Log the results when needed
			If EventLogging.Checked Then
			  myGSensor1.Logger("gsensorlog.txt", mySensorData.TiltX, mySensorData.TiltY, mySensorData.TiltZ, mySensorData.AngleX, mySensorData.AngleY)
			End If

		End Sub


	End Class

	Public Class myGSensor
		Public DetectWindowCount As Integer = 0
		Public ResetWindowCount As Integer = 0
		Private FirstTimeEntryFlag As Integer = 0

		Public Structure SensorData
			Public TiltX As Short ' From -1000 to 1000, 0 is flat
			Public TiltY As Short ' From -1000 to 1000, 0 is flat
			Public TiltZ As Short ' From -1000 to 1000, 0 = Straight up, -1000 = Flat, 1000 = Upside down
			Public Unknown1 As Short
			Public AngleY As Integer ' From 0 to 359 degrees
			Public AngleX As Integer ' From 0 to 359 degrees
			Public Unknown2 As Integer
		End Structure

		Public Structure SensorDataOld
			Public TiltX As Short ' From -1000 to 1000, 0 is flat
			Public TiltY As Short ' From -1000 to 1000, 0 is flat
			Public TiltZ As Short ' From -1000 to 1000, 0 = Straight up, -1000 = Flat, 1000 = Upside down
		End Structure

		#Region "HTCSensorSDK"

		<DllImport("HTCSensorSDK")> _
		Shared Function HTCSensorGetDataOutput(ByVal handle As IntPtr, <System.Runtime.InteropServices.Out()> ByRef sensorData As SensorData) As IntPtr
		End Function

		<DllImport("HTCSensorSDK")> _
		Shared Function HTCSensorOpen(ByVal sensor As Integer) As IntPtr
		End Function

		<DllImport("HTCSensorSDK")> _
		Shared Sub HTCSensorClose(ByVal handle As IntPtr)
		End Sub

		<DllImport("coredll", SetLastError := True)> _
		Shared Function CreateEvent(ByVal eventAttributes As IntPtr, ByVal manualReset As Boolean, ByVal intialState As Boolean, ByVal name As String) As IntPtr
		End Function

		<DllImport("coredll", SetLastError := True)> _
		Shared Function EventModify(ByVal handle As IntPtr, ByVal func As UInteger) As Boolean
		End Function

		<DllImport("coredll")> _
		Shared Function CloseHandle(ByVal handle As IntPtr) As Boolean
		End Function

		' Get a handle to an application window.
		<DllImport("coredll.dll")> _
		Private Shared Function FindWindow(ByVal lpClassName As String, ByVal lpWindowName As String) As IntPtr
		End Function

		' Activate an application window.
		<DllImport("coredll.dll")> _
		Private Shared Function SetForegroundWindow(ByVal hWnd As IntPtr) As Boolean
		End Function

		<DllImport("coredll", SetLastError := True)> _
		Private Shared Sub keybd_event(ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Integer, ByVal dwExtraInfo As Integer)
		End Sub


		#End Region

		Public Sub GetSensorData(ByRef data As SensorData)
			'Initialise and start sensor
			Dim Handle As IntPtr = HTCSensorOpen(1)
			Dim hEvent As IntPtr = CreateEvent(IntPtr.Zero, True, False, "HTC_GSENSOR_SERVICESTART")
			EventModify(hEvent, 3)
			CloseHandle(hEvent)
			HTCSensorGetDataOutput(Handle, data)

			Return
		End Sub

		Public Function DetectShake(ByVal dataold As SensorDataOld, ByVal datanew As SensorData, ByVal threshold As Integer, ByVal detectwindow As Integer, ByVal resetwindow As Integer) As Boolean
			If FirstTimeEntryFlag <> 0 Then
				'Convert values to use inbuilt Math library
				Dim Xold As Double = Convert.ToDouble(dataold.TiltX)
				Dim Yold As Double = Convert.ToDouble(dataold.TiltY)
				Dim Zold As Double = Convert.ToDouble(dataold.TiltZ)
				Dim X As Double = Convert.ToDouble(datanew.TiltX)
				Dim Y As Double = Convert.ToDouble(datanew.TiltY)
				Dim Z As Double = Convert.ToDouble(datanew.TiltZ)

				'Set new values to old
				dataold.TiltX = datanew.TiltX
				dataold.TiltY = datanew.TiltY
				dataold.TiltZ = datanew.TiltZ

				'calculate Euclidean distance between old and data points
				Dim EuclideanDistance As Double = Math.Sqrt(Math.Pow(X - Xold, 2) + Math.Pow(Y - Xold, 2) + Math.Pow(Y - Yold, 2))

				'set shake to true if distance between data points is greater than the defined threshold 
				If EuclideanDistance > threshold Then
					DetectWindowCount += 1
					If DetectWindowCount > detectwindow Then
						DetectWindowCount = 0
						ResetWindowCount = 0
						Return True
					End If
				Else
					ResetWindowCount += 1
					If ResetWindowCount > resetwindow Then
						DetectWindowCount = 0
						ResetWindowCount = 0
						Return False
					End If
				End If

			End If
			'no longer the first run.
			FirstTimeEntryFlag = 1
			Return False
		End Function

		Public Sub KeyCommandForApplication(ByVal FileName As String, ByVal VK As Byte)
			Dim p As New System.Diagnostics.Process()
			p.StartInfo.FileName = FileName
			p.Start()
			Const KEYEVENTF_KEYUP As Integer = &H02
			Const KEYEVENTF_KEYDOWN As Integer = &H00
			keybd_event(VK, 0, KEYEVENTF_KEYDOWN, 0)
			keybd_event(VK, 0, KEYEVENTF_KEYUP, 0)
		End Sub

		Public Sub Logger(ByVal FileName As String, ByVal X As Integer, ByVal Y As Integer, ByVal Z As Integer, ByVal AngleX As Integer, ByVal AngleY As Integer)
			Dim tw As TextWriter = New StreamWriter(FileName, True)
			tw.WriteLine(X.ToString() & "," & Y.ToString() & "," & Z.ToString() & "," & AngleX.ToString() & "," & AngleY.ToString())
			tw.Close()
		End Sub
	End Class
End Namespace